#!/usr/local/bin/perl5 
# expects a file with numbers
# and prints the dwt transform
# The number of time-ticks should be a power of 2
# USAGE 
#    haar.pl <fname> 

my @vals=();
my @smooth; # the smooth component of the signal
my @diff;   # the high-freq. component

# collect the values into the array @val
while(<>){
	@vals = ( @vals ,  split );
}


my $len = scalar(@vals);
my $half = int($len/2);
while($half >= 1 ){
   for(my $i=0; $i< $half; $i++){
	   $diff [$i] = ($vals[2*$i] - $vals[2*$i + 1] )/ sqrt(2);
	   print "\t", $diff[$i];
	   $smooth [$i] = ($vals[2*$i] + $vals[2*$i + 1] )/ sqrt(2);
   }
   print "\n";
   @vals = @smooth;
   $half = int($half/2);
}
print "\t", $vals[0], "\n" ;      # the final, smooth component

